package com.flexnet.external.webservice.renewal;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

import javax.jws.WebService;

import com.flexnet.external.type.PingRequest;
import com.flexnet.external.type.PingResponse;
import com.flexnet.external.type.RenewableEntitlementLineItem;
import com.flexnet.external.type.RenewableEntitlementLineItems;
import com.flexnet.external.type.RenewalResponse;
import com.flexnet.external.type.RenewalStatus;

@WebService(
	    endpointInterface="com.flexnet.external.webservice.renewal.RenewalServiceInterface",
	    wsdlLocation = "/schema/RenewalService.wsdl"
	)


public class RenewalRedirectServiceImpl implements RenewalServiceInterface{

	@Override
	public PingResponse ping(PingRequest request) throws RenewalSeviceException {
        PingResponse resp = new PingResponse();
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd-HH-mm-ss");
        resp.setStr("Renewal Redirect Service version : 1.0.0");
        resp.setProcessedTime("" + dateFormat.format(new Date()));
        return resp;
	}

	@Override
	public RenewalResponse request(RenewableEntitlementLineItems renewableEntitlementLineItems)
			throws RenewalSeviceException {
		
		RenewalResponse response = new RenewalResponse();
		response.setStatus(RenewalStatus.FAILURE);
		List<RenewableEntitlementLineItem> requestedLineItems = renewableEntitlementLineItems.getRenewableEntitlementLineItems();
		if (requestedLineItems != null && requestedLineItems.size() > 0)  {
			StringBuffer str = new StringBuffer();
			for (RenewableEntitlementLineItem req : requestedLineItems)  {
				 str.append(req.getActivationID() + "-");
			}
			response.setStatus(RenewalStatus.REDIRECT);
			response.setRedirectUrl( "https://www.google.com/search?q=" + str.toString());
		}
		return response;
	}

}
